<template>
    <div class="fit" :meta="Computed">
        <Chart ref="chart" class="fit" v-if="graph != null"
               :graph="graph.graph" :graph-setting="graph.settings" :title="graph.title"
               :floor="floor"
               :subtitle="subtitle"
        />
    </div>
</template>

<script lang='ts'>
import {Component, Prop, Vue} from 'vue-property-decorator';
import {GraphSetting} from "src/classLibrary/Charting/GraphSetting";
import Chart from "components/Core/Chart.vue";
import {GraphExportType} from "src/classLibrary/Constants";
import {format} from "date-fns";
import {WorkerChartRetriever, WorkerGraphOption} from "src/classLibrary/Charting/WorkerChart";
import {Graph, GraphValue} from "src/classLibrary/Charting/DataSet";
import {WorkerResponse} from "src/classLibrary/APIModels/core/workerResponse";
import {GraphScope} from "src/classLibrary/Charting/FloorChart";
import {FloorPrincipalResponse} from "src/classLibrary/APIModels/core/floorPrincipalResponse";

@Component({
    components: {Chart}
})
export default class WorkerChart extends Vue {
    @Prop() options!: WorkerGraphOption;
    @Prop() settings!: GraphSetting;
    @Prop() days!: string[];
    @Prop() floor!: FloorPrincipalResponse | null;

    Download(type: GraphExportType) {
        return (this.$refs.chart as any).Download(type);
    }

    subtitle = 'Total Time Spent'

    get Computed() {
        this.Graph().then(e => {
            this.graph = e
        });

        // Basically a watcher
        return this.options && this.days && this.settings;
    }

    graph: { settings: GraphSetting, graph: Graph, title: string } | null = null;

    query: WorkerChartRetriever = new WorkerChartRetriever(this.$auth, this.$analyticsApi);

    async Graph(): Promise<{ settings: GraphSetting, graph: Graph, title: string } | null> {
        const d = await this.query.Query(this.options, this.days, this.PersistentStore.StoreValue.projectName);
        if (d.isErr()) {
            console.error("error from query", d.unwrapErr());
            this.$emit('error', d.unwrapErr())
            return null;
        }
        const g = d.unwrap();
        if (g == null) return g;


        const token = await this.$auth.CoreToken;
        const r = await this.$coreApi.Get<WorkerResponse>(`Worker/${this.options.subId}/${this.options.workerId}`, null, token);
        if (r.isErr()) {
            console.error("error from query", d.unwrapErr());
            this.$emit('error', d.unwrapErr())
            return null;
        }
        const name = r.unwrap().principal.name;

        const startDate = format(new Date(this.options.startTime), "dd MMM yyyy");
        const endDate = format(new Date(this.options.endTime), "dd MMM yyyy");
        const time = this.options.range ? `${startDate} - ${endDate}` : 'All Time'
        const specFloor = this.options.type === 'line' && (this.options.floorId != '' && this.options.floorId) && this.options.merge;
        const floor = specFloor ? ` ${this.floor?.name} -` : '';
        const title = `${time}:${floor} ${name} Time Spent`;
        const data = g
        const graph: Graph = {
            type: this.options.type,
            data,
            dependentType: GraphValue.Hours(),
            valueType: GraphValue.Hours(),
            independentType: this.options.type === 'line' ? GraphValue.Date(GraphScope.Day()) : GraphValue.Original(),
        }
        return {graph, title, settings: this.settings}
    }
}
</script>

<style lang='scss' scoped>

</style>
